/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2;

import java.io.PrintStream;
import java.util.Arrays;

import org.xmloperator.lambda2.net.impl.TermReducerImpl;
import org.xmloperator.lambda2.net.model.Cell;
import org.xmloperator.lambda2.net.util.InteractionStat;
import org.xmloperator.lambda2.term.model.TermReducer;

/**
 * Test package.
 */
public abstract class MainTest {
	public static final boolean ASSERTION = false;
	public static final int[] INTERACTION_STAT = new int[Cell.INTERACTION_SYMBOLS.length];
	public static final TermReducer TERM_REDUCER = new TermReducerImpl(-1,
			INTERACTION_STAT);

	static {
		Arrays.fill(INTERACTION_STAT, 0);
	}

	private static final boolean IS_VERBOSE = false;

	public static void main(String[] args) {
		long t0 = System.currentTimeMillis();
		boolean isVerbose = IS_VERBOSE;
		if (test(System.out, isVerbose)) {
			long t1 = System.currentTimeMillis();
			System.out.println("All is OK, using " + (t1 - t0) + " ms.");
		}
		System.exit(0);
	}

	/**
	 * Executes some tests.
	 * 
	 * @param out
	 *            the PrintStream to print results.
	 * @param isVerbose
	 *            if true then all tests have to be displayed.
	 * @return true if all is Ok.
	 */
	public static boolean test(PrintStream out, boolean isVerbose) {
		boolean isOk = true;
		isOk &= org.xmloperator.lambda2.net.impl.Test.test(out, isVerbose);
		isOk &= org.xmloperator.lambda2.net.util.Test.test(out, isVerbose);
		isOk &= org.xmloperator.lambda2.term.impl.Test.test(out, isVerbose);
		isOk &= org.xmloperator.lambda2.term.util.Test.test(out, isVerbose);
		if (isOk && isVerbose)
			InteractionStat.print(out, INTERACTION_STAT);
		return isOk;
	}
}