/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.impl;

import org.xmloperator.lambda2.net.model.IntStack;

/**
 * IntStack implementation.
 */
public class IntStackImpl implements IntStack {
	protected int[] stack;
	protected int size = 0;
	
	public IntStackImpl() {
		this.stack = new int[16];
	}

	public IntStackImpl(int initialCapacity) {
		if (initialCapacity <= 0)
			throw new IllegalArgumentException();
		this.stack = new int[initialCapacity];
	}

	//////////////////////////
	// IntStack implementation
	//////////////////////////
	
	public boolean isEmpty() {
		return this.size == 0;
	}

	public void push(int value) {
		if (this.size == this.stack.length) {
			int[] newStack = new int[this.stack.length << 1];
			System.arraycopy(this.stack, 0, newStack, 0, this.size);
			this.stack = newStack;
		}
		this.stack[this.size++] = value;
	}

	public int pop() {
		if (this.size == 0)
			throw new IllegalStateException();
		return this.stack[--this.size];
	}
}
