/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.model;

/**
 * Binary cell. Constructor or Duplicator.
 */
public interface BinaryCell extends Cell {

	/**
	 * Returns the first auxiliary Port of this Cell.
	 * 
	 * @return the first auxiliary Port of this Cell.
	 */
	public Port getPort1();

	/**
	 * Returns the second auxiliary Port of this Cell.
	 * 
	 * @return the second auxiliary Port of this Cell.
	 */
	public Port getPort2();

	/**
	 * Returns true if this cell is a duplicator, false if this is a
	 * constructor.
	 * 
	 * @return true if this cell is a duplicator, false if this is a
	 *         constructor.
	 */
	public boolean isDuplicator();

	/**
	 * Changes this cell to a duplicator (if it is a constructor).
	 */
	public void changeToDuplicator();
}
