/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.model;

/**
 * Stack of <tt>long</tt> values.
 */
public interface LongStack {

	/**
	 * Returns true if this stack is empty, false elsewhere.
	 * 
	 * @return true if this stack is empty, false elsewhere.
	 */
	public boolean isEmpty();

	/**
	 * Adds a given Object to the top of this stack.
	 * 
	 * @param value
	 *            a long value.
	 */
	public void push(long value);

	/**
	 * Pops a value at the top of the stack and returns it.
	 * 
	 * @return the value at the top of the stack.
	 * @throws IllegalStateException
	 *             if the stack is empty.
	 */
	public long pop();
}