/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.net.util;

import java.io.PrintStream;
import java.util.Arrays;

import org.xmloperator.lambda2.net.model.Cell;

/**
 * Utilities about interaction statistic.
 */
public abstract class InteractionStat {

	public static final void clear(int[] interactionStat) {
		Arrays.fill(interactionStat, 0);
	}

	public static final void print(PrintStream out, int[] interactionStat) {
		out.print("Interactions:");
		int total = 0;
		for (int k = 0; k < Cell.INTERACTION_SYMBOLS.length; k++)
			if (interactionStat[k] != 0) {
				out.print(" [");
				out.print(Cell.INTERACTION_SYMBOLS[k]);
				out.print("]:");
				out.print(interactionStat[k]);
				total += interactionStat[k];
			}
		out.println(" [total]:" + total);
	}
}