/**
 * Copyright (c) 2005 The_xmloperator_project.  All rights reserved.
 * See terms of use on the project's site (http://www.xmloperator.net/lambda2/).
 */
package org.xmloperator.lambda2.term.impl;

/**
 * Application with function exponent implementation.
 */
public final class ApplicationNImpl extends Application1Impl {
	final long functionExponent;

	public ApplicationNImpl(TermImpl function, TermImpl argument,
			long functionExponent) {
		super(function, argument);
		if (functionExponent <= 0L)
			throw new IllegalArgumentException();
		this.functionExponent = functionExponent;
	}

	protected void exponentToText(StringBuffer buffer) {
		if (this.functionExponent != 1L) {
			buffer.append("^");
			buffer.append(this.functionExponent);
		}
	}

	// ///////////////////////////
	// Application implementation
	// ///////////////////////////

	public final long getFunctionExponent() {
		return this.functionExponent;
	}
}
